{{- range $service := .Values.services }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ $service.name }}
  labels:
    app: {{ $service.name }}
spec:
  replicas: {{ $.Values.replicaCount }}
  selector:
    matchLabels:
      app: {{ $service.name }}
  template:
    metadata:
      labels:
        app: {{ $service.name }}
    spec:
      containers:
        - name: {{ $service.name }}
          image: "{{ $service.image }}"
          ports:
            {{- range $port := $service.ports }}
            - containerPort: {{ $port.containerPort }}
            {{- end }}
          resources:
            {{- toYaml $.Values.resources | nindent 12 }}
          env:
            {{- range $env := $service.env }}
            - name: {{ $env.name }}
              value: {{ $env.value | quote }}
            {{- end }}
      imagePullSecrets:
        - name: {{ $.Values.imagePullSecretsName }}
---
{{- end }}


apiVersion: apps/v1
kind: Deployment
metadata:
  name: redis
  labels:
    app: redis
spec:
  replicas: 1
  selector:
    matchLabels:
      app: redis
  template:
    metadata:
      labels:
        app: redis
    spec:
      containers:
        - name: redis
          image: redis:latest
          ports:
            - containerPort: 6379
          volumeMounts:
            - mountPath: /data
              name: redis-storage
          securityContext:
            allowPrivilegeEscalation: false
      volumes:
        - name: redis-storage
          persistentVolumeClaim:
            claimName: redis-pvc
